// generated by Fast Light User Interface Designer (fluid) version 2.0001

#include "edesktopconf.h"
// Desktop background configuration for EDE is (C) Copyright 2000-2001 by Martin Pekar, this program is provided under the terms of GNU GPL v.2, see file COPYING for more information.
#include <X11/Xlib.h>
#include <fltk/fl_file_chooser.h>
#include <fltk/Fl.h>
#include <fltk/fl_config.h>
#include <fltk/Fl.h>
#include <fltk/fl_ask.h>
#include <fltk/Fl_Color_Chooser.h>
#include <fltk/x.h>
#include "edesktop.h"
static int oldBackgroundColor;

Fl_Window *windowDesktopBackgroundSettings=(Fl_Window *)0;

static void cb_Color(Fl_Button*, void*) {
  Fl_Color oldColor = desktopImageBox->color();
  Fl_Color newColor = oldColor;
  fl_color_chooser("Background color selection...", newColor);
  if (newColor != oldColor ) {
  	desktopImageBox->color(newColor);
  	desktopImageBox->parent()->redraw();
  }
;
}

static void cb_OK(Fl_Button*, void*) {
  Fl_Color backgroundColor = desktopImageBox->color();
  const char *backgroundImage = backgroundImageInput->value();
  char *globalConfigPath = new char [strlen(getenv("HOME"))+strlen("/.ede/ede.conf")+1];
  sprintf(globalConfigPath, "%s/.ede/ede.conf", getenv("HOME"));
  Fl_Config globalConfig(globalConfigPath);
  globalConfig.set("Desktop/Background color", (int)backgroundColor);
  globalConfig.set("Desktop/Background image", backgroundImage);
  delete [] globalConfigPath;
  
  uchar redColor, blueColor, greenColor;
  fl_get_color(backgroundColor, redColor, blueColor, greenColor);
  setupBackgroundColor(redColor, greenColor, blueColor);
  char *externCommand = new char[strlen(backgroundImage)+21]; 
  sprintf(externCommand, "esetbg -s \"%s\" &", backgroundImage);    
  system(externCommand);
  delete [] externCommand;
  exit(0);

}

static void cb_Apply(Fl_Button*, void*) {
  Fl_Color backgroundColor = desktopImageBox->color();
  const char *backgroundImage = backgroundImageInput->value();
  char *globalConfigPath = new char [strlen(getenv("HOME"))+strlen("/.ede/ede.conf")+1];
  sprintf(globalConfigPath, "%s/.ede/ede.conf", getenv("HOME"));
  Fl_Config globalConfig(globalConfigPath);
  globalConfig.set("Desktop/Background color", (int)backgroundColor);
  globalConfig.set("Desktop/Background image", backgroundImage);
  delete [] globalConfigPath;
  
  uchar redColor, blueColor, greenColor;
  fl_get_color(backgroundColor, redColor, blueColor, greenColor);
  setupBackgroundColor(redColor, greenColor, blueColor);
  char *externCommand = new char[strlen(backgroundImage)+21]; 
  sprintf(externCommand, "esetbg -s \"%s\" &", backgroundImage);    
  system(externCommand);
  delete [] externCommand;
  
  desktopImageBox->redraw();

}

static void cb_Cancel(Fl_Button*, void*) {
  exit(0);

}

#include <fltk/Fl_Shared_Image.h>
static const char *datas_big_monitor[] = {
  "200 160 5 1",
  " 	c None",
  ".	c #FBFFFB",
  "+	c #C3C3C3",
  "@	c #616161",
  "#	c #38FB30",
  "           ...............................................................................................................................................................................              ",
  "          .................................................................................................................................................................................             ",
  "         ...+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++.@@            ",
  "         ..+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@            ",
  "         ..+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@            ",
  "         ..+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@            ",
  "         ..+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@            ",
  "         ..+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@            ",
  "         ..+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@            ",
  "         ..++++++++@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@.++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@                                                                                                                                                             .++++++++@@            ",
  "         ..++++++++@..............................................................................................................................................................++++++++@@            ",
  "         ..+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@            ",
  "         ..+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@            ",
  "         ..+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@            ",
  "         ..+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@            ",
  "         ..+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@            ",
  "         ..+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@            ",
  "         ..+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@            ",
  "         ..+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@            ",
  "         ..@+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@@            ",
  "          @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@             ",
  "           @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@              ",
  "                       ..++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@                         ",
  "                       ..++++...........@++++...........@+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++##+++.............@++@@                         ",
  "                       ..++++.++++++++++@++++.++++++++++@+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++##+++.++++++++++++@++@@                         ",
  "                       ..++++.++++++++++@++++.++++++++++@+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++##+++.++++++++++++@++@@                         ",
  "                       ..++++.++++++++++@++++.++++++++++@+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++##+++.++++++++++++@++@@                         ",
  "                       ..++++.@@@@@@@@@@@++++.@@@@@@@@@@@+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++##+++.++++++++++++@++@@                         ",
  "                       ..++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++.@@@@@@@@@@@@@++@@                         ",
  "                       ..++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@                         ",
  "                       ..@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                         ",
  "                       .@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                         ",
  "                                                                    ..++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@                                                                    ",
  "                                                                    ..++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@                                                                    ",
  "                                                                    ..++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@                                                                    ",
  "                                                                    ..++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@                                                                    ",
  "                                                     ..............................................................................................                                                     ",
  "                                                     .............................................................................................@                                                     ",
  "                                                     ..++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@                                                     ",
  "                                                     ..++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@                                                     ",
  "                                                     ..++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@                                                     ",
  "                                                     ..++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@                                                     ",
  "                                                     ..++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@                                                     ",
  "                                                     ..++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@                                                     ",
  "                                                     ..++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@                                                     ",
  "                                                     ..++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@                                                     ",
  "                                                     ..++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++@@                                                     ",
  "                                                     ..@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                                                     ",
  "                                                     .@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                                                     "};

Fl_Box *desktopImageBox=(Fl_Box *)0;

Fl_Input *backgroundImageInput=(Fl_Input *)0;

static void cb_Browse(Fl_Button*, void*) {
  char *fileName = fl_file_chooser ( "Image selection...", "*.jpg", backgroundImageInput->value());    
  if (fileName) { 
  	backgroundImageInput->value (fileName);
  //	desktopImageBox->image(Fl_Shared_Image::guess(fileName)->get(fileName));
  //	desktopImageBox->redraw();
  }
;
}

int main (int argc, char **argv) {

  Fl_Window* w;
  char backgroundImage[1024];
  char *globalConfigPath = new char [strlen(getenv("HOME"))+strlen("/.ede/ede.conf")+1];
  sprintf(globalConfigPath, "%s/.ede/ede.conf", getenv("HOME"));
  Fl_Config globalConfig(globalConfigPath);
  globalConfig.get("Desktop/Background color", oldBackgroundColor); 
  globalConfig.get("Desktop/Background image", backgroundImage, 1024);
  delete [] globalConfigPath;
  
  if (argc>1 && (strcmp(argv[1], "--init")==0)) {
  
  uchar redColor, blueColor, greenColor;
  fl_get_color(oldBackgroundColor, redColor, blueColor, greenColor);
  setupBackgroundColor(redColor, greenColor, blueColor);
  char *externCommand = new char[strlen(backgroundImage)+21]; 
  sprintf(externCommand, "esetbg -s \"%s\" &", backgroundImage);    
  system(externCommand);
  delete [] externCommand;
  exit(0);
  }
   {  Fl_Window* o = windowDesktopBackgroundSettings = new Fl_Window(285, 350, "Background settings");
    w = o;
     {    Fl_Button* o = new Fl_Button(185, 192, 80, 23, "Color...");
      o->callback((Fl_Callback*)cb_Color);
    }
     {    Fl_Button* o = new Fl_Button(25, 317, 80, 23, "&OK");
      o->callback((Fl_Callback*)cb_OK);
    }
     {    Fl_Button* o = new Fl_Button(110, 317, 80, 23, "&Apply");
      o->callback((Fl_Callback*)cb_Apply);
    }
     {    Fl_Button* o = new Fl_Button(195, 317, 80, 23, "&Cancel");
      o->callback((Fl_Callback*)cb_Cancel);
    }
     {    Fl_Group* o = new Fl_Group(10, 10, 265, 175);
      o->image(Fl_XPM_Image::get("icons/big_monitor.xpm", (uchar*)datas_big_monitor));
      o->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
       {      Fl_Box* o = desktopImageBox = new Fl_Box(51, 17, 159, 112);
        o->box(FL_FLAT_BOX);
        o->color((Fl_Color)7);
        o->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
        o->color((Fl_Color)oldBackgroundColor );
        //o->image(Fl_Shared_Image::guess(backgroundImage)->get(backgroundImage));
      }
      o->end();
    }
     {    Fl_Group* o = new Fl_Group(10, 222, 265, 83, "Wallpaper");
      o->box(FL_ENGRAVED_BOX);
      o->align(FL_ALIGN_TOP | FL_ALIGN_LEFT);
       {      Fl_Input* o = backgroundImageInput = new Fl_Input(15, 20, 240, 23, "Image:");
        o->align(FL_ALIGN_TOP | FL_ALIGN_LEFT);
        backgroundImageInput->value(backgroundImage);
      }
       {      Fl_Button* o = new Fl_Button(175, 50, 80, 23, "&Browse...");
        o->callback((Fl_Callback*)cb_Browse);
      }
      o->end();
    }
    o->end();
  }
  w->show(argc, argv);
  return Fl::run();
}
