//  Icons settings for EDE
//  Copyright (C) 2000-2001 Martin Pekar
//
//  Requires Fast Light Tool Kit 2.0 (FLTK)
//  http://www.fltk.org - CVS access
//  http://www.agilinux.com/fltk - tar.gz archive
//
//  Author  : Martin Pekar
//  E-Mail  : cortex@nextra.sk
//  Home    : http://www.equinox.szm.sk

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "eicon.h"

int label_background;
int label_foreground;
int label_fontsize;
int label_maxwidth;
int label_gridspacing;
int label_engage_1click;

void
readIconsConfiguration()
{
    char *globalConfigPath = new char[strlen(getenv("HOME"))+strlen("/.ede/ede.conf")+1];
    sprintf(globalConfigPath, "%s/.ede/ede.conf", getenv("HOME"));
    Fl_Config globalConfig(globalConfigPath);
    
    if (globalConfig.get("IconManager/Label Background", label_background))
	label_background = LABEL_BACKGROUND;
    if (globalConfig.get("IconManager/Label Foreground", label_foreground))
	label_foreground = LABEL_FOREGROUND;
    if (globalConfig.get("IconManager/Label Fontsize", label_fontsize))
	label_fontsize = LABEL_FONTSIZE;	
    if (globalConfig.get("IconManager/Label Maxwidth", label_maxwidth))
	label_maxwidth = LABEL_MAXWIDTH;
    if (globalConfig.get("IconManager/Gridspacing", label_gridspacing))
	label_gridspacing = LABEL_GRIDSPACING;
    if (globalConfig.get("IconManager/OneClickExec", label_engage_1click))
	label_engage_1click = LABEL_ENGAGE1CLICK;
	
    delete [] globalConfigPath;
}

void
writeIconsConfiguration()
{
    char *globalConfigPath = new char[strlen(getenv("HOME"))+strlen("/.ede/ede.conf")+1];
    sprintf(globalConfigPath, "%s/.ede/ede.conf", getenv("HOME"));
    Fl_Config globalConfig(globalConfigPath);
    
    globalConfig.set("IconManager/Label Background", label_background);
    globalConfig.set("IconManager/Label Foreground", label_foreground);
    globalConfig.set("IconManager/Label Fontsize", label_fontsize);
    globalConfig.set("IconManager/Label Maxwidth", label_maxwidth);
    globalConfig.set("IconManager/Gridspacing", label_gridspacing);
    globalConfig.set("IconManager/OneClickExec", label_engage_1click);
    

    delete [] globalConfigPath;
}
