//|
//| HTML Browser for the Fast Light Tool Kit (FLTK).
//|
//| Copyright 1998-1999 by Vivality llc, Venice, CA, U.S.A. 
//|  and Matthias Melcher.
//|
//| This library is free software; you can redistribute it and/or
//| modify it under the terms of the GNU Library General Public
//| License as published by the Free Software Foundation; either
//| version 2 of the License, or (at your option) any later version.
//|
//| This library is distributed in the hope that it will be useful,
//| but WITHOUT ANY WARRANTY; without even the implied warranty of
//| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//| Library General Public License for more details.
//|
//| You should have received a copy of the GNU Library General Public
//| License along with this library; if not, write to the Free Software
//| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
//| USA.
//|
//| 
//| Changes by Martin Pekar 08/10/2001.
//| ::add function, port changes to fLTK 2.0., send bugs to cortex@nextra.sk

#ifndef ehelp_h
#define ehelp_h

#include <fltk/Fl_Widget.h>
#include <fltk/Fl_Select_Browser.h>

#include <stdio.h>

class Fl_Help : public Fl_Widget {
public:
  Fl_Help(int, int, int, int, char *name=0L);
};

typedef char *_FlString;

class Fl_Simple_Html: public Fl_Select_Browser {
public:
  Fl_Simple_Html(int, int, int, int, char *name=0L);
  virtual ~Fl_Simple_Html();
  int read(const char *html, const char *path=0L);
  int load(const char *filename, const char *path=0L);
  void gotoAnchor(const char *a);
  void clear();
  const char *url() { return url_; }
  const char *previousUrl() { return prevUrl_; }
  const char *title() { return htmlTitle; }
protected:
  int handle(int);
  int read();
  int readHtml();
  int readText();
  int readWord(_FlString &c);
  int readArg(_FlString &c);
  void rewind();
  void flush();
  void gotoTagEnd();
  void add(const char*, const char*, int n=0, void *user=0L);
  int addWord(const char *word, int n);
  void addAnchor(const char*, int);
  void addHref(const char*, int);
  void addImage(const char*, int);
protected:
  const char *inText;
  FILE *inFile;
  char *lineBuffer, *crsr, *outBuffer, *outCrsr, *docPath, *url_, *prevUrl_;
  int flags, clearFlags, indent, td, dl, heading, fsize, fontCnt;
  struct Anchor *anchor;
  int nAnchor, NAnchor;
  struct Href *href;
  int nHref, NHref;
  char *htmlTitle;
};

#endif

