//  Eiconmanager
//  Copyright (C) 2000-2001 Martin Pekar
//
//  Requires Fast Light Tool Kit 2.0 (FLTK)
//  http://www.fltk.org - CVS access
//  http://www.agilinux.com/fltk - tar.gz archive
//
//  Author  : Martin Pekar
//  E-Mail  : cortex@nextra.sk
//  Home    : http://www.equinox.szm.sk

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "eiconmanager.h"
#include "edeskicon.h"

char *globalConfigPath=0;

void 
cb_browse(Fl_Widget *, Fl_Input *input)
{
     char *f = fl_file_chooser("Choose file ...", "*", input->value() );
     if (f) input->value(f);
}

void 
run_program(Fl_Widget *w, void* data)
{
    char command[1024];
    Fl_Config flconfig( (char* ) data );
    flconfig.get("Desktop Entry/Exec", command, 1024);
    char *exec_staff = new char[ strlen( command ) + 5 ];    
    sprintf(exec_staff, "%s &", command);
    system(exec_staff);
    delete []exec_staff;
}


void 
run_utility(Fl_Widget *w, void* data)
{ 
    system( (char* ) data );
}

void
create_new_icon_cb(Fl_Widget*, void*)
{
//    make_new_icon();
}

inline void 
scan_icons(char *path)
{
    DeskIcon 	*desktopIcon;
    dirent      **files;	  
    int         num_files = 0;

    num_files = filename_list(path, &files);

    if (num_files > 0) 
    {
	
    for (int i = 0; i < num_files; i ++) {
	if (strcmp(files[i]->d_name, ".") != 0 && strcmp(files[i]->d_name, "..") != 0) {
	    char *filename = new char[strlen(path)+1+strlen(files[i]->d_name)+5]; 	 
	    sprintf(filename, "%s/%s", path, files[i]->d_name);
	  
	    if (!filename_isdir(filename) && filename_match(files[i]->d_name, "*.desktop")) {
    		desktopIcon = new DeskIcon(filename);  
		//desktopIcon->show();
	    }
        }
	free(files[i]);
    }
    free(files);
    
    }    
}

void 
cb_browse_icon(Fl_Widget *, 
	       Fl_Input  *input)
{
    char *f = fl_file_chooser("Select icon file...", "*.xpm", input->value());
    if (f)  
	input->value(f);
}

void 
cbCloseWindow(Fl_Widget *, 
	      Fl_Window *windowToClose)
{
    windowToClose->hide();
}

void
ReadIconsConfiguration()
{
//    char *globalConfigPath = new char[strlen(getenv("HOME"))+strlen("/.ede/ede.conf")+1];
  //  sprintf(globalConfigPath, "%s/.ede/ede.conf", getenv("HOME"));
    Fl_Config globalConfig(globalConfigPath);

    if (globalConfig.get("IconManager/Label Background", label_background))
	label_background = LABEL_BACKGROUND;	
    if (globalConfig.get("IconManager/Label Foreground", label_foreground))
	label_foreground = LABEL_FOREGROUND;
    if (globalConfig.get("IconManager/Label Fontsize", label_fontsize))
	label_fontsize = LABEL_FONTSIZE;	
    if (globalConfig.get("IconManager/Label Maxwidth", label_maxwidth))
	label_maxwidth = LABEL_MAXWIDTH;
    if (globalConfig.get("IconManager/Gridspacing", label_gridspacing))
	label_gridspacing = LABEL_GRIDSPACING;
    if (globalConfig.get("IconManager/OneClickExec", one_click_exec))
	one_click_exec = ONE_CLICK_EXEC ;

//    delete [] globalConfigPath;
}

int
main(int argc, char ** argv) 
{
    fl_open_display();
	
    globalConfigPath = new char[strlen(getenv("HOME"))+strlen("/.ede/ede.conf")+1];
    sprintf(globalConfigPath, "%s/.ede/ede.conf", getenv("HOME"));
	
    ReadIconsConfiguration()
;
    
    int size = strlen(getenv("HOME"))+strlen("/.ede/desktop")+1;    
    char *desktopIconHome = new char[size];
    snprintf(desktopIconHome, size, "%s/.ede/desktop", getenv("HOME"));
    
    if ((filename_isdir(desktopIconHome) > 0)){
	  scan_icons(desktopIconHome);
    }
	
    delete [] desktopIconHome;

    return Fl::run();
}


