/* Ecdinfo is based on fxcd
 * Copyright (C) 2001 Dustin Graves <dgraves@computer.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _ECDINFO_H_
#define _ECDINFO_H_

extern "C" {
#include "cdaudio.h"
}

typedef unsigned int uint;
typedef unsigned short ushort;

enum
{
  PROTO_CDDBP=0,
  PROTO_HTTP=1
};

class CDInfo
{
//  friend class CDWindow;      //For data targets
protected:
  bool proxy;
  uint cddbproto;
  ushort cddbpport;
  ushort cddbport;
  ushort cdindexport;
  ushort proxyport;
  char *cddbaddr;
  char *cdindexaddr; 
  char *proxyaddr;
  char *cddbexec;
  char *cdindexexec;

public:
  CDInfo();

  void defaultSettings(int cddesc, disc_data* info);
  bool getLocalCDDBInfo(const int cddesc, disc_data* info);
//  bool getRemoteCDDBInfo(const int &cddesc,disc_data* info,FXWindow* owner=NULL);
  bool getRemoteCDDBInfo(const int cddesc, disc_data* info);  
  bool getCDIndexInfo(const int cddesc, disc_data* info);

  bool getProxy() const;
  void setProxy(bool use);

  uint getCDDBProtocol() const;
  void setCDDBProtocol(uint proto);

  ushort getCDDBPort() const;
  void setCDDBPort(ushort port);

  ushort getCDIndexPort() const;
  void setCDIndexPort(ushort port);

  ushort getProxyPort() const;
  void setProxyPort(ushort port);

  char *getCDDBAddress() const;
  void setCDDBAddress(char *addr);

  char *getCDIndexAddress() const;
  void setCDIndexAddress(char *addr);

  char *getProxyAddress() const;
  void setProxyAddress(char *addr);

  char *getCDDBScript() const;
  void setCDDBScript(char *script);

  char *getCDIndexScript() const;
  void setCDIndexScript(char *script);

  bool getCDDBServerList(struct cddb_serverlist* list) const;
};

#endif
