//  File manager for EDE
//  Copyright (C) 2001 Martin Pekar
//
//  Requires Fast Light Tool Kit 2.0 (FLTK)
//  http://www.fltk.org - CVS access
//  http://www.agilinux.com/fltk - tar.gz archive
//
//  Author  : Martin Pekar
//  E-Mail  : cortex@nextra.sk
//  Home    : http://www.equinox.szm.sk

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "actions.h"
#include "dirbrowse.h"
#include "efmanager.h"

#include <fltk/Fl_ProgressBar.h>
#include <fltk/Fl_Check_Button.h>
#include <fltk/Fl_Item.h>
#include <fltk/Fl_Pixmap.h>
#include <fltk/Fl_Menu_Button.h>

//#include "icons/folder.xpm"
//#include "icons/editcopy.xpm"
#include "icons/exec.xpm"

char *savedArchiveDirectory;

extern int activePanel;
//int activeFtp = 2; //no ftp

extern EFileBrowser *leftPanel, *rightPanel;
extern Fl_Input *commandLine;
Fl_Check_Button *modeButtons[12];

char mode = 'I';

void 
MakeSymlink()
{
//	return (symlink(contents, name) == 0) ? TRUE : FALSE;
}	

void 
setHomeDir()
{
    EFileBrowser *activeBrowser;
    if (leftPanel->active()) 
        activeBrowser=leftPanel;
    else
        activeBrowser=rightPanel; 
	
    activeBrowser->directory(getenv("HOME"));
}

void 
changeLeft() 
{
  leftPanel->active(1);
  leftPanel->redraw();
  rightPanel->active(0);
  rightPanel->deselect();
  rightPathBox->color(FL_WHITE);
  rightPathBox->label_color(FL_BLACK);
  rightPathBox->redraw();
  leftPathBox->color(EFMmainWindow->selection_color());
  leftPathBox->label_color(FL_WHITE);
  leftPathBox->redraw();
  
  
  if (Fl::event_clicks() || Fl::event_key()==FL_Enter) {
  
    char *path = (char *)leftPanel->directory();
    char *fileName = (char *)leftPanel->text(leftPanel->value());
    char * fullPath = new char[strlen(path) + strlen(fileName)+2];
    sprintf(fullPath, "%s/%s", path, fileName);
    if (IsDirectory(fullPath)) {
      if (strstr(fullPath, "..")) {
        if ((leftPanel->panelType()==2) && strcmp(leftPanel->directory(), "/tmp/.efileman")==0) {
    	    puts("Living archive dir left");
	    leftPanel->directory(savedArchiveDirectory);
  	    leftPathBox->label(savedArchiveDirectory);
  	    leftPathBox->redraw();
	    Delete("/tmp/.efileman");
	    leftPanel->panelType(0);
        }
	else { 
        char *dirp = (char*)leftPanel->directory();
        char *oldPath;
        if (!(strcmp(dirp, "/") == 0)) {
        char  *backward = strrchr(dirp,'/');
         if ( !(backward == NULL)) {
          int pin = strlen(dirp);
  	int bin = strlen(backward);
  	oldPath = new char[strlen(dirp)+1];
  	strncpy(oldPath, dirp, pin-bin);
  	oldPath[pin-bin] = '\0';
  	leftPanel->directory(oldPath);
  	leftPathBox->label(leftPanel->directory());
  	leftPathBox->redraw();
         }
        }
      }
      }
      else {
        leftPanel->directory(fullPath);
        leftPathBox->label(fullPath); leftPathBox->redraw();
      }
    }
    else
      OpenFileAs(fullPath);
  }

}

void 
changeRight()
{
  rightPanel->active(1);
  rightPanel->redraw();
  leftPanel->active(0);
  leftPanel->deselect();
  rightPathBox->color(EFMmainWindow->selection_color());
  rightPathBox->label_color(FL_WHITE);
  rightPathBox->redraw();
  leftPathBox->color(FL_WHITE);
  leftPathBox->label_color(FL_BLACK);
  leftPathBox->redraw();
  
  if (Fl::event_clicks() || Fl::event_key() == FL_Enter) {
    char * path = (char *)rightPanel->directory();
    char * fileName = (char *)rightPanel->text(rightPanel->value());
    char * fullPath = new char[strlen(path) + strlen(fileName)+3];
    sprintf(fullPath, "%s/%s", path, fileName);
    if (IsDirectory(fullPath)) {
      if (strstr(fullPath, "..")) {
        if ((rightPanel->panelType()==2) && strcmp(rightPanel->directory(), "/tmp/.efileman")==0) {
    	    puts("Living archive dir right");
	    rightPanel->directory(savedArchiveDirectory);
  	    rightPathBox->label(savedArchiveDirectory);
  	    rightPathBox->redraw();
	    Delete("/tmp/.efileman");
	    rightPanel->panelType(0);
        }
      
        char *dirp = (char*) rightPanel->directory();
        char * oldPath;
        if (!(strcmp(dirp, "/") == 0)) {
        char  *backward = strrchr(dirp,'/');
         if ( !(backward == NULL)) {
          int pin = strlen(dirp);
  	int bin = strlen(backward);
  	oldPath = new char[strlen(dirp)+1];
  	strncpy(oldPath, dirp, pin-bin);
  	oldPath[pin-bin] = '\0';
  	rightPanel->directory(oldPath);
  	rightPathBox->label(rightPanel->directory());
  	rightPathBox->redraw();
         }
        }
      }
      else {
        rightPanel->directory(fullPath);
        rightPathBox->label(fullPath);
        rightPathBox->redraw();
      }
    }
    else
      OpenFileAs(fullPath);
  }
}

static mode_t 
mask[] = 
{
    S_ISUID, S_ISGID, S_ISVTX,  
    S_IRUSR, S_IWUSR, S_IXUSR,
    S_IRGRP, S_IWGRP, S_IXGRP,  
    S_IROTH, S_IWOTH, S_IXOTH
};

mode_t 
WhichChecked()
{
    mode_t mode = 0;

    for(unsigned int i = 0; i < sizeof mask / sizeof mask[0]; i++) {
	if(modeButtons[i]->value())
	    mode |= mask[i];
    }
    return mode;
}

void 
SaveModeButtons()  
{
    EFileBrowser *activeBrowser;
    if (leftPanel->active()) 
        activeBrowser=leftPanel;
    else
        activeBrowser=rightPanel; 

    int numberOfItems = activeBrowser->size();
    const char *path = activeBrowser->directory();
    
    for (int i=0; i<numberOfItems; ++i) {
	if (activeBrowser->selected(i)) {
	    const char *fileName = activeBrowser->text(i);	    
	    int size = strlen(path)+strlen(fileName)+2;
	    char *fullPath = new char[size];
	    snprintf(fullPath, size, "%s/%s", path, fileName);
	    if((chmod(fullPath, WhichChecked()))!=0)    
		fl_alert("Unable to change access rights.");
	    delete [] fullPath;
	}
    }	    
    activeBrowser->directory(activeBrowser->directory());
}    

int 
SetupModeButtons()  
{
    EFileBrowser *activeBrowser;
    if (leftPanel->active()) 
        activeBrowser=leftPanel;
    else
        activeBrowser=rightPanel; 

    int howMany=0;
    int numberOfItems = activeBrowser->size();
    if (numberOfItems > 0){
	for (int i=0; i<numberOfItems; ++i) {
	    if (activeBrowser->selected(i)) {
		howMany++;
	    }
	}
    }	
    if (howMany > 0) {
//    printf("%d\n", activeBrowser->panelType());
	if ((activeBrowser->panelType()==0)) {
    	    const char *path = activeBrowser->directory();
    	    const char *fileName = activeBrowser->text(activeBrowser->value());	    
    	    int size = strlen(path)+strlen(fileName)+2;
    	    char *fullPath = new char[size];
    	    snprintf(fullPath, size, "%s/%s", path, fileName);
    	    struct stat info;
    	    stat(fullPath, &info);
    	    mode_t mode = info.st_mode;
    	    delete [] fullPath;
    	    for(unsigned int i = 0; i < sizeof mask / sizeof mask[0]; i++)
		modeButtons[i]->value(mode & mask[i]);
    	    return 0;
	}
	else {
	    fl_alert("This command is supported only on local filesystem.");
	    return 1;
	}   	
    }    	
    else {
	fl_alert("Please, select some file or directory.");
	return 1;
    }	
}

void
MkDir(Fl_Button *, void *)
{
    EFileBrowser *activeBrowser;
    if (inputMkdirDialog->value()) {   
	if (leftPanel->active()) 
	    activeBrowser=leftPanel;
	else
	    activeBrowser=rightPanel; 

	if (activeBrowser->panelType()==0) {
	    const char *dirPath = activeBrowser->directory();
	    const char *dirName = inputMkdirDialog->value();
	    int s = strlen(dirName)+strlen(dirPath)+2;
	    char *dirFullPath = new char[s];
	    snprintf(dirFullPath, s, "%s/%s", dirPath, dirName);
	    if(mkdir(dirFullPath, 0644) != 0)
	        fl_alert("Cannot create directory!");
	    activeBrowser->directory(activeBrowser->directory());
	}
	if (activeBrowser->panelType()==1) {
	}
	if (activeBrowser->panelType()==2) {
	}
    }
    windowMkdirDialog->hide();
}    
/*	if (activePanel==0) {
	    if (activeFtp==0) {
		if(!(makeDirectoryFtp((char *)inputMkdirDialog->value()))) {
		    leftPanel->begin();
		    Fl_Item *dirItem = new Fl_Item(inputMkdirDialog->value());
		    //dirItem
		    leftPanel->end();
		}    
	    }
	    else {
	      if (activeFtp==1) {
		if(!(makeDirectoryFtp((char *)inputMkdirDialog->value()))) {
		    rightPanel->begin();
		    Fl_Item *dirItem = new Fl_Item(inputMkdirDialog->value());
		    //dirItem
		    rightPanel->end();
		}    
	      }
	      else {
		const char *dirPath = leftPanel->directory();
		const char *dirName = inputMkdirDialog->value();
		char *dirFullPath = new char[strlen(dirName)+strlen(dirPath)+2];
		sprintf(dirFullPath, "%s/%s", dirPath, dirName);
		if(mkdir(dirFullPath, 0644) != 0)
		    fl_alert("Cannot create directory!");
		leftPanel->directory(leftPanel->directory());
		rightPanel->directory(rightPanel->directory());
	      }	
	    }	
	}		    
    }
    else {
	    if (activeFtp) {
		makeDirectoryFtp((char *)inputMkdirDialog->value());
	    }
	    else {
		const char *dirPath = rightPanel->directory();
		const char *dirName = inputMkdirDialog->value();
		char *dirFullPath = new char[strlen(dirName) + strlen(dirPath)+3];
		sprintf(dirFullPath, "%s/%s", dirPath, dirName);
		if(mkdir(dirFullPath, 0644) != 0)
		    fl_alert("Cannot create directory!");
		leftPanel->directory(leftPanel->directory());		
		rightPanel->directory(rightPanel->directory());
	}
    }
    */
    

void 
UpdateFileCopyInfo()
{
    EFileBrowser *leftAPanel, *rightAPanel;
    if (leftPanel->active()) {
	leftAPanel = leftPanel;
	rightAPanel = rightPanel;
    }
    else {
	leftAPanel = rightPanel;
	rightAPanel = leftPanel;
    }
    
    int howMany=0;
    int numberOfItems = leftAPanel->size();
    
    if (numberOfItems > 0) {
	for (int i=0; i<numberOfItems; ++i) {
	    if (leftAPanel->selected(i)) {
		howMany++;
	    }
	}
	
	if (howMany > 1) {
	    char *text = new char[80];
	    sprintf(text, "%d selected items", howMany);
	    copySourceOutput->value(text);
	    copyToOutput->value(rightAPanel->directory());
	}
	if (howMany == 1) {
    	    for (int i=0; i<numberOfItems; ++i) {	    
		if (leftAPanel->selected(i)) {
		    char *path = (char *)leftAPanel->directory();
		    char *pathR = (char *)rightAPanel->directory();
    		    char *fileName = (char *)leftAPanel->text(i);	    
		    char *fullPath = new char[strlen(path) + strlen(fileName)+3];
		    char *fullPathR = new char[strlen(pathR) + strlen(fileName)+3];
		    sprintf(fullPath, "%s/%s", path, fileName);
		    sprintf(fullPathR, "%s/%s", pathR, fileName);
	    	    copySourceOutput->value(fullPath);	
		    copyToOutput->value(fullPathR);
		}
	    }
	}
    }
}

void 
UpdateFileMoveInfo()
{
    EFileBrowser *leftAPanel, *rightAPanel;
    if (leftPanel->active()) {
	leftAPanel = leftPanel;
	rightAPanel = rightPanel;
    }
    else {
	leftAPanel = rightPanel;
	rightAPanel = leftPanel;
    }
    int howMany = 0;
    int numberOfItems = leftAPanel->size();
    if (numberOfItems > 0){
	for (int i=0; i<numberOfItems; ++i) {
	    if (leftAPanel->selected(i)) {
		howMany++;
	    }
	}
	
	if (howMany > 1) {
	    char *text = new char[80];
	    sprintf(text, "%d selected items", howMany);	    
	    moveSourceOutput->value(text);
	    moveToOutput->value(rightAPanel->directory());
	}
	if (howMany == 1) {
	    for (int i=0; i<numberOfItems; ++i) {	    
		if (leftAPanel->selected(i)) {
		    char *path = (char *)leftAPanel->directory();
		    char *pathR = (char *)rightAPanel->directory();
    		    char *fileName = (char *)leftAPanel->text(i);	    
		    char *fullPath = new char[strlen(path) + strlen(fileName)+3];
		    char *fullPathR = new char[strlen(pathR) + strlen(fileName)+3];
		    sprintf(fullPath, "%s/%s", path, fileName);
		    sprintf(fullPathR, "%s/%s", pathR, fileName);
	    	    moveSourceOutput->value(fullPath);	
		    moveToOutput->value(fullPathR);
		}
	    }
	}
    }
}


char*  
getHomeDir()
{
    char *home = 0L; 
    char *var_home = getenv("HOME");
    if (var_home) home = var_home;
    else {
        struct passwd *user_info = getpwuid( getuid() );
        if (user_info) 
	    home = user_info->pw_dir;
    }
    return home;
}

int
IsDirectory(char * path)//look in fltk
{
    struct stat file_stat;
    if (stat (path, &file_stat) != -1) {
	if (S_ISDIR (file_stat.st_mode))
	    return 1;
    }
    return 0;
}

void 
OpenFileAs(char *file)
{
    char extExec[1024];
    Fl_Config config(PREFIX"/share/ede/mimetypes.conf");
    const char *ext = filename_ext(file);
    char *subName = new char[80];
    snprintf(subName, 80, "%s/Exec", ext);
    int result = config.get(subName, extExec, 1024);
    delete [] subName;

    if (io_is_exec (file)) {
        char *execLine = new char[strlen(file)+3];
        snprintf(execLine, strlen(file)+3, "%s &", file);
        system(execLine);
        delete [] execLine;
    }
    else {
        if (result != 0) {
	if (filename_match(file, "*.tar.gz") || filename_match(file, "*.tar.bz2") ||
	    filename_match(file, "*.zip") || filename_match(file, "*.rar")) {
	    if (leftPanel->panelType()==2 || rightPanel->panelType()==2)
		fl_alert("Only one archive can be opened at the same time.");
	    else {	
//	    fl_message("This is tar archive packed with gzip. Press OK to unpack.");
		mkdir("/tmp/.efileman", 0660);
		
	    	char *execLine;
		
		if (filename_match(file, "*.tar.gz")) {
		    execLine = new char[strlen(extExec)+ strlen(file)+30];
		    sprintf(execLine,"tar xzf \"%s\" -C /tmp/.efileman", file);
		}
		else if (filename_match(file, "*.tar.bz2")) {
		    execLine = new char[strlen(extExec)+ strlen(file)+30];
		    sprintf(execLine,"tar xyf \"%s\" -C /tmp/.efileman", file);
		}
		else if (filename_match(file, "*.zip")) {
		    execLine = new char[strlen(extExec)+ strlen(file)+30];
		    sprintf(execLine,"unzip \"%s\" -d /tmp/.efileman", file);
		}
		else { //TODO
		    
		}    
		
		system(execLine); //puts(execLine);
		delete [] execLine;
	    
		if (leftPanel->active()) {
		    savedArchiveDirectory = new char[strlen(leftPanel->directory())+1];
		    strcpy(savedArchiveDirectory, leftPanel->directory());
		    leftPanel->directory("/tmp/.efileman");
		    leftPanel->panelType(2);
		}	 
		else {
		    savedArchiveDirectory = new char[strlen(rightPanel->directory())+1];
		    strcpy(savedArchiveDirectory, rightPanel->directory());
		    rightPanel->directory("/tmp/.efileman"); 	
		    rightPanel->panelType(2);
		}	
	    }
//	    fl_alert("This is archive, sorry not yet implemented.");
	}
	else 
	    fl_alert("No program is asociated with this extension.");
	}    
	else {
	    char * execLine = new char[strlen(extExec)+ strlen(file)+8];
	    sprintf(execLine,"%s \"%s\" &", extExec, file);
	    system(execLine);
	    puts(execLine);
	    delete [] execLine;
	    leftPanel->relayout();
	    rightPanel->relayout();
	}
    }
}

void 
RunCommand(Fl_Input *, void *)
{
    char *cLine = (char *) commandLine->value();
    char *execLine = new char[strlen(cLine)+4];
    sprintf(execLine,"%s &", cLine);
    system(execLine);
    delete [] execLine;
}

void 
RunCommandButton(Fl_Button *, void *)
{
    char *cLine = (char *) commandLine->value();
    char *execLine = new char[strlen(cLine)+4];
    sprintf(execLine,"%s &", cLine);
    system(execLine);
    delete [] execLine;
}


void
CopyCb(Fl_Button *, void *)
{
    EFileBrowser *leftAPanel, *rightAPanel;
    if (leftPanel->active()) {
	leftAPanel = leftPanel;
	rightAPanel = rightPanel;
    }
    else {
	leftAPanel = rightPanel;
	rightAPanel = leftPanel;
    }
    int howMany = 0;
    int numberOfItems = leftAPanel->size();
//printf("Number of items in directory: %d\n", numberOfItems);        
    if (numberOfItems > 0) {
    	for (int i=0; i<numberOfItems; ++i) {
	    if (leftAPanel->selected(i)) {
		howMany++;
	    }
	}

	for (int i=0; i<numberOfItems; ++i) {
	    if (leftAPanel->selected(i)) {
		char *path = (char *)leftAPanel->directory();
    		char *fileName = (char *)leftAPanel->text(i);	    
		char *fullPath = new char[strlen(path) + strlen(fileName)+3];
		sprintf(fullPath, "%s/%s", path, fileName);
		if (howMany == 1) {
		    if (IsDirectory(fullPath)) {
			CopyDir(fullPath, fileName, (char *)copyToOutput->value(), 0, 0);
		    }
		    else {
			CopyFile(fullPath, fileName, (char *)copyToOutput->value(), 0, 0);		    
		    }
		}
		else {
		    if (IsDirectory(fullPath)) {
			CopyDir(fullPath, fileName, (char *)rightAPanel->directory(), 1, 0);
		    }
		    else {
			CopyFile (fullPath, fileName, (char *)rightAPanel->directory(), 1, 0);
		    }		
		}
	    }
	}
	leftAPanel->directory(leftAPanel->directory());
	rightAPanel->directory(rightAPanel->directory());
	copyDialogWindow->hide();
    }
}


void
MoveCb(Fl_Button *, 
       void 	 *)
{
    EFileBrowser * leftAPanel, *rightAPanel;
    if (leftPanel->active()) {
	leftAPanel = leftPanel;
	rightAPanel = rightPanel;
    }
    else {
	leftAPanel = rightPanel;
	rightAPanel = leftPanel;
    }
    int howMany = 0;
    int numberOfItems = leftAPanel->size();
//printf("Number of items in directory: %d\n", numberOfItems);        
    if (numberOfItems > 0){
    	    	for (int i=0; i<numberOfItems; ++i) {
		    if (leftAPanel->selected(i)) {
			howMany++;
		    }
		}

	for (int i=0; i<numberOfItems; ++i) {	
	    if (leftAPanel->selected(i)) {

		char * path = (char *)leftAPanel->directory();
    		char * fileName = (char *)leftAPanel->text(i);	    
		char * fullPath = new char[strlen(path) + strlen(fileName)+3];
		sprintf(fullPath, "%s/%s", path, fileName);
		if (howMany == 1) {
		    if (IsDirectory(fullPath)) {
			CopyDir(fullPath, fileName, (char *)moveToOutput->value(), 0, 1);
		    }
		    else {
			CopyFile (fullPath, fileName, (char *)moveToOutput->value(), 0, 1);		    
		    }
		}
		else {
		    if (IsDirectory(fullPath)) {
			CopyDir(fullPath, fileName, (char *)rightAPanel->directory(), 1, 1);
		    }
		    else {
			CopyFile (fullPath, fileName, (char *)rightAPanel->directory(), 1, 1);
		    }		
		
		}
		
		    
	    }
	}
	leftAPanel->directory(leftAPanel->directory());
	rightAPanel->directory(rightAPanel->directory());
	moveDialogWindow->hide();
    }
}


void
DeleteCb(Fl_Button 	*, 
         void 		*)
{
    EFileBrowser *leftAPanel, *rightAPanel;
    if (leftPanel->active()) {
	leftAPanel = leftPanel;
	rightAPanel = rightPanel;
    }
    else {
	leftAPanel = rightPanel;
	rightAPanel = leftPanel;
    }
    
    int numberOfItems = leftAPanel->size();
//printf("Number of items in directory: %d\n", numberOfItems);    
    if (numberOfItems > 0){
	for (int i=0; i<numberOfItems; ++i) {
	    if (leftAPanel->selected(i)) {
		char * path = (char *)leftAPanel->directory();
    		char * fileName = (char *)leftAPanel->text(i);	    
		char * fullPath = new char[strlen(path) + strlen(fileName)+3];
		sprintf(fullPath, "%s/%s", path, fileName);
    		Delete(fullPath);
	    }
	}
	leftAPanel->directory(leftAPanel->directory());
	rightAPanel->directory(rightAPanel->directory());
	deleteDialogWindow->hide();
    }
}

int
CopyFile (char *ofile, char *label, char *target, int  more, int  rem)
{
    int len, num = 0;
    struct stat stfile, stdir;
    char nfile[PATH_MAX + NAME_MAX + 1];
    char lnk[PATH_MAX + 1];
    FILE *ofp, *nfp;
    char buff[1024];
    struct utimbuf ut;

    if (leftPanel->panelType()==1 || rightPanel->panelType()==1) {
	putFileFtp(ofile, label, mode);
    }

   else {
  

    if (more) {
	if (!io_is_valid(label))
	    return (FALSE);
    }


    if (lstat(ofile, &stfile) == -1)
	return (FALSE);

    if (!io_can_write_to_parent(ofile)) {
        return (FALSE);
    }

    if (more) {
        if (access(target, W_OK | X_OK) == -1)
	    return(FALSE);
    }

    if (more) {	
        if (stat(target, &stdir) == -1)
	    return (FALSE);
	}	    
    }

    if (more) 	
        sprintf (nfile, "%s/%s", target, label);
    else
	sprintf (nfile, "%s", target);


    if (strcmp (ofile, nfile) == 0) {
        fl_alert("Source and target are the same");
	return (FALSE);
    }


    if (rem) {
	if (stfile.st_dev == stdir.st_dev) {
      /* rename */
    	    if (rename (ofile, nfile) == -1) {
		return (FALSE);
	    }
	return (TRUE);
    }
}

  // check if file is a symbolic link 
    if (S_ISLNK (stfile.st_mode)) {
	len = readlink (ofile, lnk, PATH_MAX);
        if (len <= 0) {
	    //perror ("readlink()");
	    fl_alert("Unable to read symlink!");
	    return (FALSE);
	}
	lnk[len] = '\0';
        if (symlink (lnk, nfile) == -1)
	    return (FALSE);
	if (rem) {
    	    if (unlink (ofile) == -1) {
		fl_alert("Unable to unlink symlink!");
		return (FALSE);
	    }
	}
        return (TRUE);
    }

  /* we can just rename but not copy special device files ..
   */
    if (S_ISCHR (stfile.st_mode) ||  S_ISBLK (stfile.st_mode) ||
	S_ISFIFO (stfile.st_mode) || S_ISSOCK (stfile.st_mode))  {
	fl_alert ("Can't copy device, fifo and socket files as regular files!");
	return 0;	
    }
  /* copy and delete
   */

    ofp = fopen (ofile, "rb");
    if (!ofp)
	return (0);
	
    nfp = fopen (nfile, "wb");
    if (!nfp) {
	fclose (ofp);
        return (0);
    }
    
    int all = 0;    

    if (rem) {
	moveProgressbar->maximum((double)stfile.st_size);    
        moveProgressbar->showtext(1);    
    }
    else {
	copyProgressBar->maximum((double)stfile.st_size);    
        copyProgressBar->showtext(1);    
    }	

    while ((num = fread (buff, 1, 1024, ofp)) > 0) {
        fwrite (buff, 1, num, nfp);
        all += num;
	if (rem) {
	    moveProgressbar->position((double)all);
	}
	else {
	    copyProgressBar->position((double)all);
	}
	Fl::flush();
    }
    fclose (nfp);
    fclose (ofp);

    ut.actime = stfile.st_atime; // reset time stamps
    ut.modtime = stfile.st_mtime;
    utime (nfile, &ut);

    chmod (nfile, stfile.st_mode); // set access rights

    if (rem) {  
	if (unlink (ofile) != 0)
	    return (FALSE);
    }    

    return (TRUE);
}

int
CopyDir(char *source, char *label, char *target, int more, int rem)
{
    DIR *dir;
    int len = 0;
    struct dirent *de;
    struct stat st_source, st_target, st_file;
    char new_path[PATH_MAX + 1];
    char file[PATH_MAX + NAME_MAX + 1];
    char name[NAME_MAX + 1];
    char *tempFile;

    if (more) {
	if (access (target, X_OK | W_OK) != 0) {
	    //alert
    	    perror (target);
    	    return (FALSE);
	}
    }    
    
    if (access (source, X_OK | R_OK) != 0) {
	perror (source);
        return (FALSE);
    }
    if (more) {    
	if (lstat (target, &st_target) != 0) {
    	    perror (target);
        return (FALSE);
	}
    }    
    if (lstat (source, &st_source) != 0) {
	perror (target);
        return (FALSE);
    }

    if (more) {
	if (!(io_is_valid (label)))
	    return (FALSE);
    }    
    
    if (more)     
	sprintf (new_path, "%s/%s", target, label);
    else	
	sprintf (new_path, "%s", target);

//  while (++num)
//    {
//      if (lstat (new_path, &st_file) == 0)
//	{
//	  if (!trash)
//	    return (FALSE);
	  /* dir still exists, we have to rename */
//	  sprintf (new_path, "%s/%s;%d", target, label, num);
//	}
//      else
//	break;
//    }
    
    if (rem) {
	if (st_source.st_dev == st_target.st_dev) {
    	    if (rename (source, new_path) == -1)
		return (FALSE);
    	    return (TRUE);
	}
	if (!S_ISDIR (st_source.st_mode)) {
//printf ("Moving file..\n");
	    return CopyFile (source, label, target, more, 0);
	}
    }
  /* we have to copy .. */
    dir = opendir (source);
    if (!dir) {
	perror (source);
	return (FALSE);
    }

    if (mkdir (new_path, 0xFFFF) == -1) {
	perror (source);
        closedir (dir);
        return (FALSE);
    }

    while ((de = readdir (dir)) != NULL) {
	len = strlen (de->d_name);
        if (((len == 1) && (*de->d_name == '.')) ||
	    ((len == 2) && (de->d_name[0] == '.') && (de->d_name[1] == '.'))) {
		continue;
	}
        strcpy (name, de->d_name);
        sprintf (file, "%s/%s", source, name);
        if (lstat (file, &st_file) != 0) {
	    perror (file);
	    return (FALSE);
	}
	
	if (!more) {
    	    tempFile = new char[strlen(name) + strlen(new_path) + 3];
	    sprintf(tempFile, "%s/%s", new_path, name);
	}
    if (S_ISDIR (st_file.st_mode)) { // it is a directory
	if (rem) {
	    if (more) {
		if (CopyDir(file, name, new_path, more, 1) != TRUE) {
		    printf ("move_dir() recursive failed\n");
		    return (FALSE);
		}
	    }
	    else {
		if (CopyDir(file, name, tempFile, more, 1) != TRUE) {	    
		    printf ("move_dir() recursive failed\n");
		    return (FALSE);
		}
	    }
	
	
	}
	else {
	    if (more) {
		if (CopyDir(file, name, new_path, more, 0) != TRUE) {
		    printf("move_dir() recursive failed\n");
		    return (FALSE);
		}
	    }
	    else {
		if (CopyDir(file, name, tempFile, more, 0) != TRUE) {	    
		    printf("move_dir() recursive failed\n");
		    return (FALSE);
		}
	    }
	}    
	
    } //end of else - not dir
	else {
	if (rem) {	
		
	    if (more) {
		if (CopyFile (file, name, new_path, more, 1) != TRUE) {	  
		    printf ("move_dir() move_file() failed\n");
        	    return (FALSE);
		}
	    }
	    else {
		if (CopyFile (file, name, tempFile, more, 1) != TRUE) {	  
	    	    printf ("move_dir() move_file() failed\n");
	    	    return (FALSE);
		}
	    }
	}
	else {
	    if (more) {
		if (CopyFile (file, name, new_path, more, 0) != TRUE) {	  
	    	    printf ("move_dir() move_file() failed\n");
	    	    return (FALSE);
		}
	    }
	    else {
		if (CopyFile (file, name, tempFile, more, 0) != TRUE) {	  
	    	    printf ("move_dir() move_file() failed\n");
	    	    return (FALSE);
		}
	    }
	
	}
	    
	}//else not dir
	    if (!more) 
		delete [] tempFile;
    }

    closedir (dir);
    
    if (rem) {  
	rmdir (source);
    }
    return (TRUE);
}


void
Delete(char *path)
{
  struct stat st;
  DIR *dir;
  char *test;
  struct dirent *de;
  char complete[PATH_MAX + NAME_MAX + 1];

  if (lstat (path, &st) == -1)
    {
      perror (path);
      return;
    }
  if ((test = strrchr (path, '/')))
    {
      test++;
      if (!io_is_valid (test))
	return;
    }
  if (S_ISDIR (st.st_mode) && (!S_ISLNK (st.st_mode)))
    {
      if (access (path, R_OK | W_OK) == -1)
	{
	  return;
	}
      dir = opendir (path);
      if (!dir)
	{
	  return;
	}
      while ((de = readdir (dir)) != NULL)
	{
	  if (io_is_current (de->d_name))
	    continue;
	  if (io_is_dirup (de->d_name))
	    continue;
	  sprintf (complete, "%s/%s", path, de->d_name);
	  Delete(complete);
	}
      closedir (dir);
      rmdir (path);
    }
  else
    {
      unlink (path);
    }
}


extern char **environ;

/*
 * check is named file is an executable
 * return the mode field, so we don't have to stat() again if
 * we need some further informations
 */
int
io_is_exec (char *file)
{
  struct stat file_stat;
  if (stat (file, &file_stat) != -1)
    {
      if ((!S_ISDIR (file_stat.st_mode)) && (file_stat.st_mode & S_IXUSR ||
					     file_stat.st_mode & S_IXGRP ||
					     file_stat.st_mode & S_IXOTH))
	return (file_stat.st_mode);
    }
  return (0);
}

/*
 * is named file a directory
 */
int
io_is_directory (char *path)
{
  struct stat file_stat;
  if (stat (path, &file_stat) != -1)
    {
      if (S_ISDIR (file_stat.st_mode))
	return (1);
    }
  return (0);
}

/*
 * is named file a directory
 */
int
io_is_file (char *path)
{
  struct stat file_stat;
  if (stat (path, &file_stat) != -1)
    {
      if (S_ISREG (file_stat.st_mode))
	return (file_stat.st_mode);
    }
  return (0);
}

/*
 */
int
io_can_exec (char *file)
{
  if (access (file, X_OK) != -1)
    return (1);
  return (0);
}

/*
 */
int
io_can_write_to_parent (char *file)
{
  char *p;
  char path[PATH_MAX + 1];
  p = strrchr (file, '/');
  if (p)
    {
      strncpy (path, file, p - file + 1);
      path[p - file + 1] = '\0';
    }
  else
    strcpy (path, ".");
  if (access (path, W_OK | X_OK) == -1)
    return (0);
  return (1);
}


 
int
io_system (char *cmd)
{
  int pid, status;
  int nulldev;

  if (cmd == NULL)
    return (1);
  pid = fork ();
  if (pid == -1)
    return (-1);
  if (pid == 0)
    {
      char *argv[4];
      /* child */
      argv[0] = "sh";
      argv[1] = "-c";
      argv[2] = cmd;
      argv[3] = NULL;

      /* The following is to avoid X locking when executing 
         terminal based application that requires user input */
      if ((nulldev = open ("/dev/null", O_RDWR)))
        {
          close (0); dup (nulldev);
          close (1); dup (nulldev);
          close (2); dup (nulldev);
        }

      if (execve ("/bin/sh", argv, environ) == -1)
	perror ("/bin/sh");
      _exit (127);
    }
  do
    {
      if (waitpid (pid, &status, 0) == -1)
	{
	  if (errno != EINTR)
	    return (-1);
	}
      else
	return status;
    }
  while (1);
}

/*
 */
 /*
static void
sig_seg (int signum)
{
  fprintf (stderr, "segmention fault (pid=%d)\n", (int) getpid ());
  exit (127);
}

*/
/*
 */
int
io_system_var (char **arg, int len)
{
  pid_t pid;
  int status, i;
//  void *old;
//  int old;

  if ((arg == NULL) || (len == 0))
    return -1;
  if (access (*arg, X_OK) != 0)
    return -1;
//  old = signal (SIGSEGV, sig_seg);

  pid = fork ();
  if (pid == -1)
    {
      perror ("fork()");
      return (-1);
    }

  if (pid == 0)
    {
      /* child process */
      char **argv = (char **) malloc (sizeof (char *) * (len + 2));
      if (!argv)
	_exit (127);
      for (i = 0; i < len; i++)
	{
	  argv[i] = arg[i];
	}
      argv[len] = NULL;
      if (execve (argv[0], argv, environ) == -1)
	{
	  perror (argv[0]);
	  _exit (127);
	}
    }
  /* parent process */
  sleep (1);
  do
    {
      if (waitpid (pid, &status, WNOHANG) == -1)
	{
	  if (errno != EINTR)
	    return (-1);
	}
      else
	{
	  if (WIFEXITED (status))
	    {
	      if (WEXITSTATUS (status) == 127)
		return -1;
	      else
		return WEXITSTATUS (status);
	    }
	  return 0;
	}
    }
  while (1);
}


int
io_item_exists (char *path)
{
  struct stat s;
  if (stat (path, &s) != -1) {
    return (s.st_mode);
  }
  return (0);
}

