/*
    Scicalc+ : a scientific calculator for X - version 0.86     
    Copyright (C)  2001    Ivano Primi ( ivano.primi@tin.it )    

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You can contact the author of this software by paper mail writing to
    the next address

	Ivano Primi
	via Colle Cannetacce 50/A
	C.A.P. 00038 - Valmontone (ROMA)
	Italy                                                          .

    If you prefer the electronic mail you can write to the address

	ivano.primi@tin.it                                             .
*/

/* Scicalc.h */
#ifndef _Scicalc_

#define _Scicalc_

#define PI 3.14159265358979324

#define MAX_LUN 201
/*
  Dimensione massima delle espressioni matematiche analizzabili dal
  programma
*/

#define MAX_CHAR 30
/*
  Numero massimo dei caratteri utilizzati nella
  scrittura di un numero
*/

#define HIST_SIZE 24
/*
  Definisce la dimensione dell'history delle espressioni digitate
*/

#define MEM_NUMB 1296
/*
  Definisce il numero di memorie disponibili
*/

#define SQRT_MEM_NUMB 36
/*
  Definisce la radice quadrata di MEM_NUMB
*/

#define FATAL_ERROR 10000

struct item
{
	char *psz;
	short prec;
};
/*
  Per l'uso di item cfr. Scicalc.c
*/

struct coppia
{
	short prec,index;
};
/*
  Per l'uso di coppia vedi Command.c
*/

/*Dichiarazione delle funzioni contenute nei vari moduli del programma*/

double round(double d);
double intp(double d);
double frac(double d);
long trunc(double d);
double vald(const char *s,int *codice_errore);
void Delete_spaces(char *s);
void Transform(char *s);
short Call_function(char *nome_fun,char *argument);
short Call_operation(char *operando1,char *operando2,char operazione);
/* void Stat(void); */
int isoperation(char c);
int isnumberelement(char c);
int isnumbercomponent(char c);
int ischarmathematic(char c);
int ischaragreable(char c);
short Check_Move(char* expr,short* memonum,short* nel);
short Interpreter(short nel);
char* Evaluate(const char* input,const char* command,int precision,int* coderr);

#endif
#define DATADIR "/usr/local/share/sccplus"
